<id>
din1031:MultiLingualBoardDescription
</id>

<version>
1.1.0
</version>

<edit file>
$sourcedir/MessageIndex.php
</edit file>

<search for>
					'name' => $row_board['name'],
					'description' => return_boardDecription($row_board['description'], $row_board['ID_BOARD']),
</search for>

<replace>
					'name' => return_boardName($row_board['name'], $row_board['ID_BOARD']),
					'description' => return_boardDecription($row_board['description'], $row_board['ID_BOARD']),
</replace>

<search for>
				'id' => $row['ID_BOARD'],
				'name' => $row['name'],
				'description' => return_boardDecription($row['description'], $row['ID_BOARD']),
</search for>

<replace>
				'id' => $row['ID_BOARD'],
				'name' => return_boardName($row['name'], $row['ID_BOARD']),
				'description' => return_boardDecription($row['description'], $row['ID_BOARD']),
</replace>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
		- load language specific board descriptions
</search for>

<replace>
		- load language specific board descriptions
		- load language specific board names
</replace>

<search for>
		- load_bvoardDescriptions must be done before that it correct work
</search for>

<replace>
		- load_boardDescriptions must be done before that it correct work

	string return_boardName(string orginal, int board, string language = '')
		- return the correct language string for the board name
		- if the name not exists it use the standard version
		- load_boardDescriptions must be done before that it correct work
</replace>

<search for>
function load_boardDescriptions($boardids = false, $lang = '', $forceUpdate = false) {
	global $context, $modSettings, $language, $user_info, $sourcedir, $db_prefix;
	
	//With that a Admin can force a disable of this option!
	if($context['user']['is_admin'] && isset($_REQUEST['DisableFileCache']))
		updateSettings(array('mui_bords_language_file_chache' => '0'));
	
	$filename = $sourcedir.'/ChacheBoardDescription.php';
	//Load the Chache file?
	if(!empty($modSettings['mui_bords_language_file_chache']) && empty($context['board_description']) && file_exists($sourcedir.'/ChacheBoardDescription.php') && $forceUpdate === false) {
		include_once($filename);
		return true;
	}
	//Please use this only if you really enable a chache :x
	if($forceUpdate !== false && empty($modSettings['mui_bords_language_file_chache']))
		return false;
	
	if($forceUpdate !== false) {
		$boardids = false;
		$lang = false;
	}
	$sql = array();
	
	if($boardids !== false) {
		if(is_array($boardids)) {
			foreach($boardids as $key => $id)
				$boardids[$key] = (int) $id;
		}
		else {
			$boardids = (int) $boardids;
			$boardids = array($boardids);
		}
		$boardids = array_unique($boardids);
		//Error?
		if(empty($boardids))
			return false;
	}

	if($lang !== false && empty($lang))
		$lang = !empty($user_info['language']) ? $user_info['language'] : $language;

	if(!isset($context['board_description']))
		$context['board_description'] = array();
	
	//Make a checkup and generate empty inserts if needed *g*
	if($lang !== false && $boardids !== false) {
		foreach($boardids as $key => $id) {
			if($lang === false && isset($context['board_description'][$id]))
				unset($boardids[$key]);
			elseif(isset($context['board_description'][$id][$lang]))
				unset($boardids[$key]);
			elseif($lang === false)
				$context['board_description'][$id] = array();
			else
				$context['board_description'][$id][$lang] = array();
		}
		
		//Pheew checkup done, prepare querys or not?
		if(empty($boardids))	
			return true;
		else {
			$sql[] = 'id_board IN ('.implode(',', $boardids).')';
			if($lang !== false)
				$sql[] = 'language = '.$lang;
		}
	}

	//Load Data ;)	
	$request = db_query("
		SELECT id_board, language, description
		FROM {$db_prefix}boards_language".(!empty($sql) ? "
		WHERE ".implode(" AND ", $sql) : ""), __FILE__, __LINE__);
	
	if(mysql_num_rows($request) == 0) {
		mysql_free_result($request);
		return false;
	}
	while($row = mysql_fetch_assoc($request))
		$context['board_description'][$row['id_board']][$row['language']] = $row['description'];

	//Let's see if this is a update of the chache file 
	if($forceUpdate !== false && is_writable($filename)) {
		$file_insert = '$context[\'board_description\'] = array('; 
		//Master Array
		foreach($context['board_description'] as $id_board => $languages) {
		$file_insert .= '
		\''.$id_board.'\' => array(';
			if(!empty($languages)) {
				foreach($languages as $language => $text) {
					$file_insert .= '
			\''.$language.'\' => \''.addslashes($text).'\',';
				}
			}
			$file_insert .= '
		),';
		}
		$file_insert .= '
	);'; 
	
		$file_content = '<?php
//Store the $context[\'board_decription\'] Array only! For the fast cache load!
if (!defined(\'SMF\'))
	die(\'Hacking attempt...\'); 
'.$file_insert.'

?>';
	
		//Write the file
		$handle = @fopen($filename, 'w'); 
		@fwrite($handle, $file_content);
		fclose($handle);
	}
	return true;
}

function return_boardDecription($orginal = '', $id_board = 0, $lang = '') {
	global $context, $language, $user_info;

	//Okay i do nothing ;)
	if(empty($id_board) || empty($context['board_description'][$id_board]))
		return $orginal;

	if($lang !== false && empty($lang))
		$lang = !empty($user_info['language']) ? $user_info['language'] : $language;
	
	if(!empty($context['board_description'][$id_board][$lang]))
		return $context['board_description'][$id_board][$lang];
	else
		return $orginal;
}
</search for>

<replace>
function load_boardDescriptions($boardids = false, $lang = '', $forceUpdate = false) {
	global $context, $modSettings, $language, $user_info, $sourcedir, $db_prefix;
	
	//With that a Admin can force a disable of this option!
	if($user_info['is_admin'] && isset($_REQUEST['DisableFileCache']))
		updateSettings(array('mui_bords_language_file_chache' => '0'));
	
	$filename = $sourcedir.'/ChacheBoardDescription.php';
	//Load the Chache file?
	if(!empty($modSettings['mui_bords_language_file_chache']) && empty($context['board_description']) && file_exists($sourcedir.'/ChacheBoardDescription.php') && $forceUpdate === false) {
		include_once($filename);
		return true;
	}
	//Please use this only if you really enable a chache :x
	if($forceUpdate !== false && empty($modSettings['mui_bords_language_file_chache']))
		return false;
	
	if($forceUpdate !== false) {
		$boardids = false;
		$lang = false;
	}
	$sql = array();
	
	if($boardids !== false) {
		if(is_array($boardids)) {
			foreach($boardids as $key => $id)
				$boardids[$key] = (int) $id;
		}
		else {
			$boardids = (int) $boardids;
			$boardids = array($boardids);
		}
		$boardids = array_unique($boardids);
		//Error?
		if(empty($boardids))
			return false;
	}

	if($lang !== false && empty($lang))
		$lang = !empty($user_info['language']) ? $user_info['language'] : $language;

	if(!isset($context['board_description']))
		$context['board_description'] = array();
	if(!isset($context['board_name']))
		$context['board_name'] = array();
	
	//Make a checkup and generate empty inserts if needed *g*
	if($lang !== false && $boardids !== false) {
		foreach($boardids as $key => $id) {
			if($lang === false && isset($context['board_description'][$id]))
				unset($boardids[$key]);
			elseif(isset($context['board_description'][$id][$lang]))
				unset($boardids[$key]);
			elseif($lang === false)
				$context['board_description'][$id] = array();
			else
				$context['board_description'][$id][$lang] = array();
		}
		
		//Pheew checkup done, prepare querys or not?
		if(empty($boardids))	
			return true;
		else {
			$sql[] = 'id_board IN ('.implode(',', $boardids).')';
			if($lang !== false)
				$sql[] = "language = '$lang'";
		}
	}
	
	//Load Data ;)	
	$request = db_query("
		SELECT id_board, language, name, description
		FROM {$db_prefix}boards_language".(!empty($sql) ? "
		WHERE ".implode(" AND ", $sql) : ""), __FILE__, __LINE__);
	
	if(mysql_num_rows($request) == 0) {
		mysql_free_result($request);
		return false;
	}
	while($row = mysql_fetch_assoc($request)) {
		$context['board_description'][$row['id_board']][$row['language']] = $row['description'];
		$context['board_name'][$row['id_board']][$row['language']] = $row['name'];
	}

	//Let's see if this is a update of the chache file 
	if($forceUpdate !== false && is_writable($filename)) {
		$file_insert = '	$context[\'board_description\'] = array('; 
		//Master Array
		foreach($context['board_description'] as $id_board => $languages) {
		$file_insert .= '
		\''.$id_board.'\' => array(';
			if(!empty($languages)) {
				foreach($languages as $language => $text) {
					$file_insert .= '
			\''.$language.'\' => \''.addslashes($text).'\',';
				}
			}
			$file_insert .= '
		),';
		}
		$file_insert .= '
	);'; 
	
		$file_insert .= '
	$context[\'board_name\'] = array('; 
		foreach($context['board_name'] as $id_board => $languages) {
		$file_insert .= '
		\''.$id_board.'\' => array(';
			if(!empty($languages)) {
				foreach($languages as $language => $text) {
					$file_insert .= '
			\''.$language.'\' => \''.addslashes($text).'\',';
				}
			}
			$file_insert .= '
		),';
		}
		$file_insert .= '
	);'; 

		$file_content = '<?php
//Store the $context[\'board_decription\'] Array only! For the fast cache load!
if (!defined(\'SMF\'))
	die(\'Hacking attempt...\'); 
'.$file_insert.'

?>';
	
		//Write the file
		$handle = @fopen($filename, 'w'); 
		@fwrite($handle, $file_content);
		fclose($handle);
	}
	return true;
}

function return_boardDecription($orginal = '', $id_board = 0, $lang = '') {
	global $context, $language, $user_info;

	//Okay i do nothing ;)
	if(empty($id_board) || empty($context['board_description'][$id_board]))
		return $orginal;

	if($lang !== false && empty($lang))
		$lang = !empty($user_info['language']) ? $user_info['language'] : $language;
	
	if(!empty($context['board_description'][$id_board][$lang]))
		return $context['board_description'][$id_board][$lang];
	else
		return $orginal;
}

function return_boardName($orginal = '', $id_board = 0, $lang = '') {
	global $context, $language, $user_info;

	//Okay i do nothing ;)
	if(empty($id_board) || empty($context['board_name'][$id_board]))
		return $orginal;

	if($lang !== false && empty($lang))
		$lang = !empty($user_info['language']) ? $user_info['language'] : $language;
	
	if(!empty($context['board_name'][$id_board][$lang]))
		return $context['board_name'][$id_board][$lang];
	else
		return $orginal;
}
</replace>

<search for>
		if (count(array_intersect($user_info['groups'], $board_info['groups'])) == 0 && !$user_info['is_admin'])
			$board_info['error'] = 'access';
</search for>

<replace>
		if (count(array_intersect($user_info['groups'], $board_info['groups'])) == 0 && !$user_info['is_admin'])
			$board_info['error'] = 'access';

		//Load the language specific boardinfomation :D and replace it
		load_boardDescriptions($board);
		$board_info['name'] = return_boardName($board_info['name'], $board);
		$board_info['description'] = return_boardDecription($board_info['name'], $board);
</replace>

<edit file>
$sourcedir/BoardIndex.php
</edit file>

<search for>
					'new' => empty($row_board['isRead']),
					'id' => $row_board['ID_BOARD'],
					'name' => $row_board['boardName'],
					'description' => return_boardDecription($row_board['description'], $row_board['ID_BOARD']),
</search for>

<replace>
					'new' => empty($row_board['isRead']),
					'id' => $row_board['ID_BOARD'],
					'name' => return_boardName($row_board['boardName'], $row_board['ID_BOARD']),
					'description' => return_boardDecription($row_board['description'], $row_board['ID_BOARD']),
</replace>

<search for>
				'name' => $row_board['boardName'],
				'description' => return_boardDecription($row_board['description'], $row_board['ID_BOARD']),
				'new' => empty($row_board['isRead']) && $row_board['posterName'] != '',
</search for>

<replace>
				'name' => return_boardName($row_board['boardName'], $row_board['ID_BOARD']),
				'description' => return_boardDecription($row_board['description'], $row_board['ID_BOARD']),
				'new' => empty($row_board['isRead']) && $row_board['posterName'] != '',
</replace>

<edit file>
$sourcedir/ManageBoards.php
</edit file>

<search for>
function EditLanguages() {
	global $txt, $db_prefix, $context, $sourcedir, $settings, $language, $func;
	
	//Make a check up ;D
	if(!isset($_REQUEST['boardid']))
		redirectexit('action=manageboards');
	else
		$_REQUEST['boardid'] = (int) $_REQUEST['boardid'];
	
	if(empty($_REQUEST['boardid']))
		redirectexit('action=manageboards');

	loadTemplate('ManageBoards');
	require_once($sourcedir.'/Subs-Post.php');
	if (isset($_POST['save']))
	{
		checkSession();
		//Prepare the data :D
		foreach($_POST['board_descriptions'] as $language => $items) {
			preparsecode($items['text']);
			if(empty($items['id']) || !isset($items['id']))
				//Okay Insert it into the db :D
				db_query("
					INSERT INTO {$db_prefix}boards_language
						(id_board, language, description)
					VALUES ($_REQUEST[boardid], '$language', '$items[text]')", __FILE__, __LINE__);
			else
				db_query("
					UPDATE {$db_prefix}boards_language
						SET description = '$items[text]'
					WHERE id_board_translation = $items[id]", __FILE__, __LINE__);
		}
		//Update the chache now 8)
		if(!empty($modSettings['mui_bords_language_file_chache']))
			load_boardDescriptions(false, false, true);
		redirectexit('action=manageboards');
	}
	
	$context['board_descriptions'] = array();
	$context['languages'] = array();

	//Standard Language 8) is Board Language i need this to know the current one
	$context['boardLanguage'] = empty($modSettings['boardLanguage']) ? $language : $modSettings['boardLanguage'];

	//Check if the board exists...
	$context['board_info'] = array();

	$request = db_query("
		SELECT ID_BOARD, name, description FROM {$db_prefix}boards
		WHERE ID_BOARD = $_REQUEST[boardid]
		LIMIT 1", __FILE__, __LINE__);
	
	if(mysql_num_rows($request) == 0)
		redirectexit('action=manageboards');
	else
		$context['board_info'] = mysql_fetch_assoc($request);	
	mysql_free_result($request);

	//Load the Data from the database 8)
	$request = db_query("
		SELECT * FROM {$db_prefix}boards_language
		WHERE id_board = $_REQUEST[boardid]", __FILE__, __LINE__);
	while($row = mysql_fetch_assoc($request)) {
		$context['board_descriptions'][$row['language']] = array(
			'id' => $row['id_board_translation'],
			'name' => $func['ucwords']($row['language']),
			'text' => un_preparsecode(preg_replace('~<br(?: /)?' . '>~i', "\n", $row['description'])),
		);
	}
	mysql_free_result($request);
	
	if(empty($context['board_descriptions'])) {
		// Get the current agreement.
		$context['board_descriptions']['english'] = array(
			'id' => 0,
			'name' => 'English',
			'text' => $context['board_info']['description'],
		);
	}

	//Let's see, which language is missing, fill it with empty strings *g*
	$language_directories = array(
		$settings['default_theme_dir'] . '/languages',
		$settings['actual_theme_dir'] . '/languages',
	);
	if (!empty($settings['base_theme_dir']))
		$language_directories[] = $settings['base_theme_dir'] . '/languages';
	$language_directories = array_unique($language_directories);

	foreach ($language_directories as $language_dir)
	{
		// Can't look in here... doesn't exist!
		if (!file_exists($language_dir))
			continue;

		$dir = dir($language_dir);
		while ($entry = $dir->read())
		{
			// Look for the index language file....
			if (preg_match('~^index\.(.+)\.php$~', $entry, $matches) == 0)
				continue;
			
			$name = strtr($matches[1], array('_' => ' ', '-utf8' => ''));
	
			if($name != 'english')
				$context['languages'][] = $name;
	
			if(isset($context['board_descriptions'][$name]))
				continue;
			
			$context['board_descriptions'][$name] = array(
				'id' => 0,
				'name' => $func['ucwords']($name),
				'text' => '',
			);
		}
		$dir->close();
	}
	$context['languages'] = array_unique($context['languages']);
	$context['sub_template'] = 'edit_mui_board_language';
	$context['page_title'] = $txt['mui_bords_language'];
}
</search for>

<replace>
function EditLanguages() {
	global $txt, $db_prefix, $context, $sourcedir, $settings, $language, $func;
	global $modSettings;
	
	//Make a check up ;D
	if(!isset($_REQUEST['boardid']))
		redirectexit('action=manageboards');
	else
		$_REQUEST['boardid'] = (int) $_REQUEST['boardid'];
	
	if(empty($_REQUEST['boardid']))
		redirectexit('action=manageboards');

	loadTemplate('ManageBoards');
	require_once($sourcedir.'/Subs-Post.php');
	if (isset($_POST['save']))
	{
		checkSession();
		//Prepare the data :D
		foreach($_POST['board_descriptions'] as $language => $items) {
			preparsecode($items['text']);
			if(empty($items['id']) || !isset($items['id']))
				//Okay Insert it into the db :D
				db_query("
					INSERT INTO {$db_prefix}boards_language
						(id_board, language, description)
					VALUES ($_REQUEST[boardid], '$language', '$items[text]')", __FILE__, __LINE__);
			else
				db_query("
					UPDATE {$db_prefix}boards_language
						SET description = '$items[text]'
					WHERE id_board_translation = $items[id]", __FILE__, __LINE__);
		}
		foreach($_POST['board_descriptions'] as $language => $items) {
			if(!empty($items['text']))
				preparsecode($items['text']);
			else
				$items['text'] = '';

			if(!empty($_POST['board_names'][$language]['text'])) {
				$name = $_POST['board_names'][$language]['text'];
				preparsecode($name);
				unset($_POST['board_names'][$language]);
			}
			else
				$name = '';
			
			if(empty($items['id']) || !isset($items['id']))
				//Okay Insert it into the db :D
				db_query("
					INSERT INTO {$db_prefix}boards_language
						(id_board, language, description, name)
					VALUES ($_REQUEST[boardid], '$language', '$items[text]', '$name')", __FILE__, __LINE__);
			else
				db_query("
					UPDATE {$db_prefix}boards_language
						SET description = '$items[text]', name = '$name'
					WHERE id_board_translation = $items[id]", __FILE__, __LINE__);
		}
		//Update the chache now 8)
		if(!empty($modSettings['mui_bords_language_file_chache']))
			load_boardDescriptions(false, false, true);
		redirectexit('action=manageboards');
	}
	
	$context['board_descriptions'] = array();
	$context['languages'] = array();

	//Standard Language 8) is Board Language i need this to know the current one
	$context['boardLanguage'] = empty($modSettings['boardLanguage']) ? $language : $modSettings['boardLanguage'];

	//Check if the board exists...
	$context['board_info'] = array();

	$request = db_query("
		SELECT ID_BOARD, name, description FROM {$db_prefix}boards
		WHERE ID_BOARD = $_REQUEST[boardid]
		LIMIT 1", __FILE__, __LINE__);
	
	if(mysql_num_rows($request) == 0)
		redirectexit('action=manageboards');
	else
		$context['board_info'] = mysql_fetch_assoc($request);	
	mysql_free_result($request);

	//Load the Data from the database 8)
	$request = db_query("
		SELECT * FROM {$db_prefix}boards_language
		WHERE id_board = $_REQUEST[boardid]", __FILE__, __LINE__);
	while($row = mysql_fetch_assoc($request)) {
		$context['board_descriptions'][$row['language']] = array(
			'id' => $row['id_board_translation'],
			'name' => $func['ucwords']($row['language']),
			'text' => un_preparsecode(preg_replace('~<br(?: /)?' . '>~i', "\n", $row['description'])),
		);
		$context['board_names'][$row['language']] = array(
			'id' => $row['id_board_translation'],
			'name' => $func['ucwords']($row['language']),
			'text' => un_preparsecode(preg_replace('~<br(?: /)?' . '>~i', "\n", $row['name'])),
		);
	}
	mysql_free_result($request);
	
	if(empty($context['board_descriptions'])) {
		// Get the current board information.
		$context['board_descriptions']['english'] = array(
			'id' => 0,
			'name' => 'English',
			'text' => $context['board_info']['description'],
		);
	}
	if(empty($context['board_names'])) {
		$context['board_names']['english'] = array(
			'id' => 0,
			'name' => 'English',
			'text' => $context['board_info']['name'],
		);
	}

	//Let's see, which language is missing, fill it with empty strings *g*
	$language_directories = array(
		$settings['default_theme_dir'] . '/languages',
		$settings['actual_theme_dir'] . '/languages',
	);
	if (!empty($settings['base_theme_dir']))
		$language_directories[] = $settings['base_theme_dir'] . '/languages';
	$language_directories = array_unique($language_directories);

	foreach ($language_directories as $language_dir)
	{
		// Can't look in here... doesn't exist!
		if (!file_exists($language_dir))
			continue;

		$dir = dir($language_dir);
		while ($entry = $dir->read())
		{
			// Look for the index language file....
			if (preg_match('~^index\.(.+)\.php$~', $entry, $matches) == 0)
				continue;
			
			$name = strtr($matches[1], array('_' => ' ', '-utf8' => ''));
	
			if($name != 'english')
				$context['languages'][] = $name;
	
			if(!isset($context['board_descriptions'][$name])) {
				$context['board_descriptions'][$name] = array(
					'id' => 0,
					'name' => $func['ucwords']($name),
					'text' => '',
				);
			}
			if(!isset($context['board_names'][$name])) {
				$context['board_names'][$name] = array(
					'id' => 0,
					'name' => $func['ucwords']($name),
					'text' => '',
				);
			}
		}
		$dir->close();
	}
	$context['languages'] = array_unique($context['languages']);
	$context['sub_template'] = 'edit_mui_board_language';
	$context['page_title'] = $txt['mui_bords_language'];
}
</replace>

<edit file>
$sourcedir/Stats.php
</edit file>

<search for>
	$context['top_boards'] = array();
	$max_num_posts = 1;
	while ($row_board = mysql_fetch_assoc($boards_result))
	{
		$context['top_boards'][] = array(
</search for>

<replace>
	$context['top_boards'] = array();
	$max_num_posts = 1;
	//Load all board description data for this language
	load_boardDescriptions(false);
	while ($row_board = mysql_fetch_assoc($boards_result))
	{
		//Lol thats so nice ;D i translate the boardname for you
		$row_board['name'] = return_boardName($row_board['name'], $row_board['ID_BOARD']);
		$context['top_boards'][] = array(
</replace>

<edit file>
$sourcedir/Profile.php
</edit file>

<search for>
	$context['board_notifications'] = array();
	while ($row = mysql_fetch_assoc($request))
		$context['board_notifications'][] = array(
			'id' => $row['ID_BOARD'],
			'name' => $row['name'],
			'href' => $scripturl . '?board=' . $row['ID_BOARD'] . '.0',
			'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['name'] . '</a>',
			'new' => $row['boardRead'] < $row['ID_MSG_UPDATED']
		);
	mysql_free_result($request);
</search for>

<replace>
	$context['board_notifications'] = array();
	load_boardDescriptions(false);
	while ($row = mysql_fetch_assoc($request)) 
	{
		$row['name'] = return_boardName($row['name'], $row['ID_BOARD']);
		$context['board_notifications'][] = array(
			'id' => $row['ID_BOARD'],
			'name' => $row['name'],
			'href' => $scripturl . '?board=' . $row['ID_BOARD'] . '.0',
			'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['name'] . '</a>',
			'new' => $row['boardRead'] < $row['ID_MSG_UPDATED']
		);
	}
	mysql_free_result($request);
</replace>

<search for>
		$context['topic_notifications'][] = array(
</search for>

<replace>
		$row['name'] = return_boardName($row['name'], $row['ID_BOARD']);
		$context['topic_notifications'][] = array(
</replace>

<search for>
	$board_ids = array('own' => array(), 'any' => array());
	while ($row = mysql_fetch_assoc($request))
	{
		// Censor....
</search for>

<replace>
	$board_ids = array('own' => array(), 'any' => array());
	load_boardDescriptions(false);
	while ($row = mysql_fetch_assoc($request))
	{
		$row['bname'] = return_boardName($row['bname'], $row['ID_BOARD']);
		// Censor....
</replace>

<edit file>
$sourcedir/Search.php
</edit file>

<search for>
	$context['num_boards'] = mysql_num_rows($request);
	$context['categories'] = array();
</search for>

<replace>
	$context['num_boards'] = mysql_num_rows($request);
	$context['categories'] = array();
	load_boardDescriptions(false);
</replace>

<search for>
		// Set this board up, and let the template know when it's a child.  (indent them..)
		$context['categories'][$row['ID_CAT']]['boards'][$row['ID_BOARD']] = array(
</search for>

<replace>
		//Replace the boardname to the language specific one.
		$row['name'] = return_boardName($row['name'], $row['ID_BOARD']);

		// Set this board up, and let the template know when it's a child.  (indent them..)
		$context['categories'][$row['ID_CAT']]['boards'][$row['ID_BOARD']] = array(
</replace>

<search for>
		// Get the messages out for the callback - select enough that it can be made to look just like Display.
</search for>

<replace>
		//Get all language Specific Descriptions...
		load_boardDescriptions(false);

		// Get the messages out for the callback - select enough that it can be made to look just like Display.
</replace>

<search for>
	$output = array_merge($context['topics'][$message['ID_MSG']], array(
</search for>

<replace>
	//Replace it ;D
	$message['bName'] = return_boardName($message['bName'], $message['ID_BOARD']);

	$output = array_merge($context['topics'][$message['ID_MSG']], array(
</replace>

<edit file>
$sourcedir/Recent.php
</edit file>

<search for>
		LIMIT $showlatestcount", __FILE__, __LINE__);
	$posts = array();
</search for>

<replace>
		LIMIT $showlatestcount", __FILE__, __LINE__);
	$posts = array();
	//Preload all board description for this language, this is the fastest way to make it workable...
	load_boardDescriptions(false);
</replace>

<search for>
			$row['body'] = $func['substr']($row['body'], 0, 128) . '...';

		// Build the array.
		$posts[] = array(
</search for>

<replace>
			$row['body'] = $func['substr']($row['body'], 0, 128) . '...';

		//Replace the boardname to the language specific one.
		$row['bName'] = return_boardName($row['bName'], $row['ID_BOARD']);

		// Build the array.
		$posts[] = array(
</replace>


<search for>
	$counter = $_REQUEST['start'] + 1;
	$context['posts'] = array();
</search for>

<replace>
	$counter = $_REQUEST['start'] + 1;
	$context['posts'] = array();
	//Preload all board description for this language, this is the fastest way to make it workable...
	load_boardDescriptions(false);
</replace>

<search for>
		// BBC-atize the message.
		$row['body'] = parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MSG']);

		// And build the array.
		$context['posts'][$row['ID_MSG']] = array(
</search for>

<replace>
		// BBC-atize the message.
		$row['body'] = parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MSG']);

		//Replace the boardname to the language specific one.
		$row['bname'] = return_boardName($row['bname'], $row['ID_BOARD']);

		// And build the array.
		$context['posts'][$row['ID_MSG']] = array(
</replace>

<search for>
		$context['querystring_board_limits'] = ';start=%d';
		$context['no_board_limits'] = true;
	}
</search for>

<replace>
		$context['querystring_board_limits'] = ';start=%d';
		$context['no_board_limits'] = true;
	}

	//Chacka i know the boards ;D i love smf ;P did someone read this *g*
	load_boardDescriptions($boards);
</replace>

<search for>
		// And build the array.
		$context['topics'][$row['ID_TOPIC']] = array(
</search for>

<replace>
		//Replace the boardname for this language:D
		$row['bname'] = return_boardName($row['bname'], $row['ID_BOARD']);

		// And build the array.
		$context['topics'][$row['ID_TOPIC']] = array(
</replace>

<edit file>
$themedir/ManageBoards.template.php
</edit file>

<search for>
					<div id="'.$language.'Item" style="display:block;">
					<textarea cols="70" rows="10" name="board_descriptions['.$language.'][text]" style="width: 94%; margin-bottom: 1ex;">', $agree['text'], '</textarea><br />
</search for>

<replace>
					<div id="'.$language.'Item" style="display:block; text-align:left;">
					<input type="hidden" name="board_names['.$language.'][id]" value="'.$context['board_names'][$language]['id'].'" />
					'.$txt[20].': <input type="text" size="70" style="width: 84%; margin-bottom: 1ex;" name="board_names['.$language.'][text]" value="'.$context['board_names'][$language]['text'].'" />
					<textarea cols="70" rows="10" name="board_descriptions['.$language.'][text]" style="width: 94%; margin-bottom: 1ex;">', $agree['text'], '</textarea><br />
</replace>


